/*
 * $Id: Lbr.as,v 1.2 2007/09/02 03:58:02 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package {
  import flash.display.Sprite;
  import flash.display.Bitmap;
  import flash.display.BitmapData;
  import flash.events.Event;
  import flash.events.KeyboardEvent;
  import flash.media.Sound;
  import abagames.util.KeyState;
  import abagames.lbr.MainLoop;

  /**
   * Lbr bootstrap.
   */
  public class Lbr extends Sprite {
    [Embed(source='sounds/lbr_1.mp3')]
    private var SoundBgm:Class;
    [Embed(source='sounds/shot.mp3')]
    private var SoundShot:Class;
    [Embed(source='sounds/burst_ball.mp3')]
    private var SoundBurstBall:Class;
    [Embed(source='sounds/burst_mine.mp3')]
    private var SoundBurstMine:Class;
    [Embed(source='sounds/player_miss.mp3')]
    private var SoundPlayerMiss:Class;
    [Embed(source='sounds/get_energy.mp3')]
    private var SoundGetEnergy:Class;
    [Embed(source='sounds/warning.mp3')]
    private var SoundWarning:Class;
    [Embed(source='sounds/get_smallenergy.mp3')]
    private var SoundGetSmallEnergy:Class;
    [Embed(source='sounds/extend.mp3')]
    private var SoundExtend:Class;
    public static const SCREEN_WIDTH:int = 360;
    public static const SCREEN_HEIGHT:int = 480;
    private var rootSprite:Sprite;
    private var mainLoop:MainLoop;
    private var keyState:KeyState;
    private var isFirst:Boolean = true;
    private var sounds:Array;

    public function Lbr() {
      sounds = new Array;
      sounds.push(new SoundBgm);
      sounds.push(new SoundShot);
      sounds.push(new SoundBurstBall);
      sounds.push(new SoundBurstMine);
      sounds.push(new SoundPlayerMiss);
      sounds.push(new SoundGetEnergy);
      sounds.push(new SoundWarning);
      sounds.push(new SoundGetSmallEnergy);
      sounds.push(new SoundExtend);
      addEventListener(Event.ENTER_FRAME, onEnterFrame);
    }

    public function onEnterFrame(evt:Event):void {
      if (isFirst) {
        isFirst = false;
        mainLoop = new MainLoop;
        keyState = new KeyState;
        rootSprite = this;
        stage.addEventListener(KeyboardEvent.KEY_DOWN, keyState.onKeyDown);
        stage.addEventListener(KeyboardEvent.KEY_UP, keyState.onKeyUp);
        var buffer:BitmapData = new BitmapData(SCREEN_WIDTH, SCREEN_HEIGHT, false, 0);
        var screen:Bitmap = new Bitmap(buffer);
        rootSprite.addChild(screen);
        mainLoop.init(rootSprite, keyState, buffer, screen, sounds);
      }
      mainLoop.update();
    }
  }
}
