/*
 * $Id: ApeParticleActor.as,v 1.1.1.1 2007/08/19 01:14:45 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package abagames.lbr {
  import org.cove.ape.AbstractParticle;
  import org.cove.ape.Group;
  import org.cove.ape.Vector;
  import abagames.util.SimpleActor;

  /**
   * Actor that moves according to an APE particle.
   */
  public class ApeParticleActor extends SimpleActor {
    protected var _particle:AbstractParticle;
    protected var group:Group;
    protected var _pos:abagames.util.Vector;
    private var forceVector:Vector;

    public function ApeParticleActor() {
      _pos = new abagames.util.Vector;
    }

    public function setGroup(group:Group):void {
      this.group = group;
      forceVector = new Vector;
    }

    public function addToGroup():void {
      group.addParticle(_particle);
    }

    public function removeFromGroup():void {
      group.removeParticle(_particle);
    }

    public override function update():void {
      _pos.x = _particle.px;
      _pos.y = _particle.py;
    }

    public function setPos(x:Number, y:Number): void {
      _pos.x = _particle.px = x;
      _pos.y = _particle.py = y;
    }

    public function addForce(x:Number, y:Number):void {
      forceVector.x = x;
      forceVector.y = y;
      _particle.addForce(forceVector);
    }

    public function get particle():AbstractParticle {
      return _particle;
    }

    public function get pos():abagames.util.Vector {
      return _pos;
    }
  }
}
