/*
 * $Id: Energy.as,v 1.3 2007/09/02 03:58:04 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package abagames.lbr {
  import flash.display.BitmapData;
  import org.cove.ape.Group;
  import org.cove.ape.CircleParticle;
  import abagames.util.Vector;

  /**
   * Energy item.
   */
  public class Energy extends ApeParticleActor {
    private var buffer:BitmapData;
    private var field:Field;
    private var player:Player;
    private var particles:ParticlePool;
    private var cnt:int;
    private var shape:Shape;

    public function Energy(buffer:BitmapData, field:Field, player:Player,
                         particles:ParticlePool, group:Group) {
      this.buffer = buffer;
      this.field = field;
      this.player = player;
      this.particles = particles;
      shape = new Shape(buffer, field);
      shape.addBox(0, -10, 15, 5, 0, 255, 0);
      shape.addBox(0, 0, 15, 5, 0, 255, 0);
      shape.addBox(0, 10, 15, 5, 0, 255, 0);
      shape.addBox(-10, 0, 5, 20, 0, 255, 0);
      _particle = new CircleParticle(0, 0, 15);
      _particle.mass = 3;
      _particle.friction = 0.01;
      setGroup(group);
    }

    public function add(x:Number, y:Number):void {
      setPos(x, y);
      cnt = 0;
      addToGroup();
      _particle.visible = false;
    }

    public override function update():void {
      super.update();
      if (!field.isInYUpper(_pos.y)) {
        remove();
        return;
      }
      if (player.hasCollision && _pos.dist(player.pos) < 40) {
        player.getEnergy();
        for (var i:int = 0; i < 32; i++) {
          var p:Particle = Particle(particles.getInstanceForced());
          p.add(_pos.x, _pos.y, Math.random() * Math.PI * 2, 2, 0, 255, 0, 0.2);
        }
        remove();
        return;
      }
      cnt++;
      if (cnt % 3 == 0) {
        var pt:Particle = Particle(particles.getInstanceForced());
        pt.add(_pos.x, _pos.y, Math.random() * Math.PI * 2, 3, 0, 255, 0, 0);
      }
      addForce(0, -Field.GRAVITY * (3 + Math.sin(cnt * 0.2) * 3));
      shape.drawDistorted(_pos);
    }

    public function drawShape(p:Vector):void {
      shape.drawWithoutScroll(p);
    }

    public override function remove():void {
      removeFromGroup();
      super.remove();
    }
  }
}
