/*
 * $Id: Floor.as,v 1.3 2007/09/06 12:35:42 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package abagames.lbr {
  import flash.display.BitmapData;
  import org.cove.ape.Group;
  import org.cove.ape.RectangleParticle;
  import abagames.util.Vector;

  /**
   * Floor connected with cords to a field.
   */
  public class Floor extends ApeParticleActor {
    public static const WIDTH:Number = 30;
    private var buffer:BitmapData;
    private var field:Field;
    private var cords:CordPool;
    private var shape:Shape;

    public function Floor(buffer:BitmapData, field:Field, cords:CordPool, group:Group) {
      this.buffer = buffer;
      this.field = field;
      this.cords = cords;
      shape = new Shape(buffer, field);
      shape.addBox(0, 0, WIDTH, 10, 200, 200, 200);
      _particle = new RectangleParticle(0, 0, WIDTH, 10);
      setGroup(group);
    }

    public function add(x:Number, y:Number, fixed:Boolean = false):void {
      setPos(x, y);
      addToGroup();
      _particle.visible = false;
      _particle.mass = 1;
      _particle.fixed = fixed;
    }

    public override function update():void {
      if (!field.isInY(_pos.y)) {
        remove();
        return;
      }
      super.update();
      shape.draw(_pos);
    }

    public override function remove():void {
      cords.removeConnected(this);
      removeFromGroup();
      super.remove();
    }
  }
}
