/*
 * $Id: SolidBallPool.as,v 1.1 2007/09/06 12:35:42 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package abagames.lbr {
  import flash.display.BitmapData;
  import org.cove.ape.Group;
  import abagames.util.Actor;
  import abagames.util.ActorPool;
  import abagames.util.Vector;

  /**
   * Solid ball pool.
   */
  public class SolidBallPool extends ActorPool {
    private var buffer:BitmapData;
    private var field:Field;
    private var player:Player;
    private var fragments:FragmentPool;
    private var particles:ParticlePool;
    private var sound:SoundHandler;
    private var group:Group;

    public function SolidBallPool(n:int, buffer:BitmapData, field:Field, player:Player,
                           fragments:FragmentPool, particles:ParticlePool,
                           sound:SoundHandler, group:Group) {
      this.buffer = buffer;
      this.field = field;
      this.player = player;
      this.fragments = fragments;
      this.particles = particles;
      this.sound = sound;
      this.group = group;
      super(n);
    }

    protected override function createActor():Actor {
      return new SolidBall(buffer, field, player, fragments, particles, sound, group);
    }

    public function destroy():void {
      var an:int = actorNum;
      for (var i:int = 0; i < an; i++)
        SolidBall(actors[0]).destroy(false);
    }
  }
}
