/*
 * $Id: SoundHandler.as,v 1.3 2007/09/06 12:35:42 kenta Exp $
 *
 * Copyright 2007 Kenta Cho. Some rights reserved.
 */
package abagames.lbr {
  import flash.media.Sound;
  import flash.media.SoundChannel;
  import flash.media.SoundTransform;

  /**
   * Handling BGMs and SEs.
   * (SEs: 1-Shot, 2-Burst(Ball), 3-Burst(Mine), 4-Player missing,
   *       5-Getting energy, 6-Energy warning,
   *       7-Getting smallEnergy, 8-Extend)
   */
  public class SoundHandler {
    private var sounds:Array;
    private var bgmChannel:SoundChannel;
    private var bgmTransform:SoundTransform;
    private var bgmFadeout:Boolean;

    public function SoundHandler(sounds:Array) {
      this.sounds = sounds;
      bgmTransform = new SoundTransform;
    }

    public function startBgm():void {
      bgmTransform.volume = 1;
      bgmFadeout = false;
      bgmChannel = sounds[0].play(0, 99999, bgmTransform);
    }

    public function fadeoutBgm():void {
      bgmFadeout = true;
    }

    public function stopBgm():void {
      bgmFadeout = false;
      if (bgmChannel != null)
        bgmChannel.stop();
      bgmChannel = null;
    }

    public function playSe(n:int, loop:int = 1, st:SoundTransform = null):SoundChannel {
      return sounds[n].play(0, loop, st);
    }

    public function setVolumeAndPan(sc:SoundChannel, vol:Number, pan:Number):void {
      if (sc == null)
        return;
      var st:SoundTransform = sc.soundTransform;
      st.volume = vol;
      st.pan = pan;
      sc.soundTransform = st;
    }

    public function update():void {
      if (bgmChannel != null) {
        Shape.distortion = 0.5 + (bgmChannel.leftPeak + bgmChannel.rightPeak) * 0.5;
        if (bgmFadeout) {
          bgmTransform.volume -= 0.015;
          if (bgmTransform.volume <= 0.05) {
            bgmTransform.volume = 0;
            bgmFadeout = false;
          }
          bgmChannel.soundTransform = bgmTransform;
        }
      } else {
        Shape.distortion = 1;
      }
    }
  }
}
